VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Cls_SERIO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Private Declare Function SendPacket Lib "PICBOOT.dll" (ByVal hComPort As Long, PacketData As Byte, ByVal NumOfBytes As Integer) As Integer
Private Declare Function GetPacket Lib "PICBOOT.dll" (ByVal hComPort As Long, PacketData As Byte, ByVal NumOfBytesLim As Integer) As Integer
Private Declare Function OpenPIC Lib "PICBOOT.dll" (ByVal ComPort As String, ByVal BitRate As Long, ByVal ReadTimeOut As Long) As Long
Private Declare Function ClosePIC Lib "PICBOOT.dll" (ByVal hComPort As Long) As Integer
Private Declare Function SendGetPacket Lib "PICBOOT.dll" (ByVal hComPort As Long, PacketData As Byte, ByVal NumOfBytes As Integer, ByVal NumOfBytesLim As Integer, ByVal NumOfRetrys As Integer) As Integer
Private Declare Function ReadPIC Lib "PICBOOT.dll" (ByVal hComPort As Long, LPpic As PIC, MemData As Byte) As Integer
Private Declare Function WritePIC Lib "PICBOOT.dll" (ByVal hComPort As Long, LPpic As PIC, MemData As Byte) As Integer
Private Declare Function VerifyPIC Lib "PICBOOT.dll" (ByVal hComPort As Long, LPpic As PIC, MemData As Byte) As Integer



Private Type PIC                 'structure used in communications DLL
    BootCmd As Byte
    BootDatLen As Byte
    BootAddr As Long
    BytesPerBlock As Byte
    BytesPerAddr As Byte
    MaxRetrys As Integer
End Type


'local variable(s) to hold property value(s)
Private mvarPortHandle As Long 'local copy
Private mvarBitRate As Long 'local copy
Private mvarComPort As String 'local copy
Private mvarRecvTimeOut As Long 'local copy

Private mvarBoot As PIC




Public Property Let RecvTimeOut(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.RecvTimeOut = 5
    mvarRecvTimeOut = vData
End Property


Public Property Get RecvTimeOut() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RecvTimeOut
    RecvTimeOut = mvarRecvTimeOut
End Property







Public Property Let MaxRetrys(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.MaxRetrys = 5
    mvarBoot.MaxRetrys = vData
End Property


Public Property Get MaxRetrys() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.MaxRetrys
    MaxRetrys = mvarBoot.MaxRetrys
End Property



Public Property Let BytesPerAddr(ByVal vData As Byte)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BytesPerAddr = 5
    mvarBoot.BytesPerAddr = vData
End Property


Public Property Get BytesPerAddr() As Byte
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BytesPerAddr
    BytesPerAddr = mvarBoot.BytesPerAddr
End Property



Public Property Let BytesPerBlock(ByVal vData As Byte)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BytesPerBlock = 5
    mvarBoot.BytesPerBlock = vData
End Property


Public Property Get BytesPerBlock() As Byte
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BytesPerBlock
    BytesPerBlock = mvarBoot.BytesPerBlock
End Property



Public Property Let BootAddr(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BootAddr = 5
    mvarBoot.BootAddr = vData
End Property


Public Property Get BootAddr() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BootAddr
    BootAddr = mvarBoot.BootAddr
End Property



Public Property Let BootDataLen(ByVal vData As Byte)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BootDataLen = 5
    mvarBoot.BootDatLen = vData
End Property


Public Property Get BootDataLen() As Byte
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BootDataLen
    BootDataLen = mvarBoot.BootDatLen
End Property



Public Property Let BootCmd(ByVal vData As Byte)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BootCmd = 5
    mvarBoot.BootCmd = vData
End Property


Public Property Get BootCmd() As Byte
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BootCmd
    BootCmd = mvarBoot.BootCmd
End Property


Public Property Let ComPort(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ComPort = 5
    mvarComPort = vData
End Property


Public Property Get ComPort() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ComPort
    ComPort = mvarComPort
End Property



Public Property Let BitRate(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BitRate = 5
    mvarBitRate = vData
End Property


Public Property Get BitRate() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BitRate
    BitRate = mvarBitRate
End Property



Public Property Let PortHandle(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PortHandle = 5
    mvarPortHandle = vData
End Property


Public Property Get PortHandle() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PortHandle
    PortHandle = mvarPortHandle
End Property



Public Function SERWrite(PacketData() As Byte, Optional ByVal lDataAddress As Long = -1, Optional ByVal lDataLen As Integer = -1, Optional ByVal lPortHandle As Long = -1) As Integer
    If lDataAddress >= 0 Then
        mvarBoot.BootAddr = lDataAddress
    End If
    
    If lDataLen >= 0 Then
        mvarBoot.BootDatLen = lDataLen
    End If
    
    If lPortHandle >= 0 Then
        mvarPortHandle = lPortHandle
    End If

    SERWrite = WritePIC(mvarPortHandle, mvarBoot, PacketData(0))
End Function

Public Function SERRead(Optional ByVal lDataAddress As Long = -1, Optional ByVal lDataLen As Integer = -1, Optional ByVal lPortHandle As Long = -1) As Byte()
    If lDataAddress >= 0 Then
        mvarBoot.BootAddr = lDataAddress
    End If
    
    If lDataLen >= 0 Then
        mvarBoot.BootDatLen = lDataLen
    End If
    
    If lPortHandle >= 0 Then
        mvarPortHandle = lPortHandle
    End If
    
    
    ReDim InData(mvarBoot.BootDatLen + 6) As Byte
        
    If ReadPIC(mvarPortHandle, mvarBoot, InData(0)) >= 0 Then
        SERRead = InData
    End If
End Function

Public Function SERClose(Optional ByVal lPortHandle As Long = -1) As Integer
    If lPortHandle >= 0 Then
        mvarPortHandle = lPortHandle
    End If
    
    SERClose = ClosePIC(mvarPortHandle)
    mvarPortHandle = 0
End Function

Public Function SEROpen() As Long
    mvarPortHandle = OpenPIC(mvarComPort, mvarBitRate, mvarRecvTimeOut)
    SEROpen = mvarPortHandle
End Function
