VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{E64F6D86-2DF6-450F-991A-294876090850}#2.0#0"; "CANCtl.ocx"
Begin VB.Form F_Feedback 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "CAN Bootloader"
   ClientHeight    =   375
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4470
   Icon            =   "F_Feedback.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   375
   ScaleWidth      =   4470
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer T_WatchDog 
      Enabled         =   0   'False
      Left            =   600
      Top             =   480
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3360
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
      Scrolling       =   1
   End
   Begin mchpCAN.CANComm CANComm1 
      Left            =   2520
      Top             =   360
      _ExtentX        =   1005
      _ExtentY        =   1005
   End
End
Attribute VB_Name = "F_Feedback"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const STATUS_CONNECTED As String = "Communications opened: "
Const STATUS_CONNECTED_CAN As String = "Connected to the CAN bus..."
Const STATUS_DISCONNECTED As String = "Communications closed..."
Const STATUS_DISCONNECTED_CAN As String = "Leaving the CAN bus..."
Const STATUS_EXAMIN_FILE As String = "Examining file: "
Const STATUS_VALID_HEX As String = "Valid HEX file..."
Const STATUS_INVALID_HEX As String = "Invalid HEX file..."
Const STATUS_NOFILE As String = "No HEX file selected..."

Const STATUS_FAILED_TO_OPEN_PORT As String = "Failed to open port..."
Const ERR_BAD_HEX As String = "Invalid HEX file..."


Const HEX_FILE_CONTROL_STRING As String = "INHEX32 Files (*.HEX)|*.HEX|All Files (*.*)|*.*"

Dim AbortFlag As Boolean
Dim ProgFlag As Boolean
Dim WatchDogTimer As Integer
Dim pWatchDogTimer As Integer
Dim CANCtlBits As mchpCANControl

Dim pINIFileName As String

Dim pRegions As Variant
Dim pHEXFileName() As String
Dim pCANCtlId As Long
Dim pCANDataId As Long
Dim pBootCtlCode As Byte
Dim pStartAddr() As Long
Dim pEndAddr() As Long
Dim pBlockSize() As Byte
Dim pProgressBlock() As Integer


Private Sub Form_Load()
    Dim MyString As String
    Dim INIFilePath As String
    Dim CommandLine As String
    Dim CmdParamIndex
    
    INIFilePath = VB.App.Path & "\" & VB.App.EXEName & ".INI"
    MyString = "                                                          "

    CommandLine = Command()
    
      

    crap = VB.App.EXEName
    crap = VB.App.Path
       
    F_DebugWindow.Show vbModeless
        
    crap = GetPrivateProfileString("CANBOOT", "commport", "2", MyString, 20, INIFilePath)
    CANComm1.CommPort = CInt(MyString)
    
'    CmdParamIndex = InStr(1, CommandLine, "-b")
 '   If CmdParamIndex > 0 Then
'        MyString = Mid(CommandLine, CmdParamIndex + 2, InStr(CmdParamIndex + 1, CommandLine, "-") - CmdParamIndex - 2)
'    Else
        crap = GetPrivateProfileString("CANBOOT", "bitrate", "57600", MyString, 20, INIFilePath)
        
 '   End If
    CANComm1.BitRate = CLng(MyString)
    
    crap = GetPrivateProfileString("CANBOOT", "can_prescale", "1", MyString, 20, INIFilePath)
    CANCtlBits.mchp_BRP = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_capture", "0", MyString, 20, INIFilePath)
    CANCtlBits.mchp_CANCAP = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_drivetx", "1", MyString, 20, INIFilePath)
    CANCtlBits.mchp_ENDRHI = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_proptime", "2", MyString, 20, INIFilePath)
    CANCtlBits.mchp_PRSEG = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_3xsample", "0", MyString, 20, INIFilePath)
    CANCtlBits.mchp_SAM = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_phase1", "7", MyString, 20, INIFilePath)
    CANCtlBits.mchp_SEG1PH = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_phase2", "7", MyString, 20, INIFilePath)
    CANCtlBits.mchp_SEG2PH = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_phase2free", "1", MyString, 20, INIFilePath)
    CANCtlBits.mchp_SEG2PHTS = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_sjw", "3", MyString, 20, INIFilePath)
    CANCtlBits.mchp_SJW = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "can_filter", "0", MyString, 20, INIFilePath)
    CANCtlBits.mchp_WAKFIL = CInt(MyString)
    
    crap = GetPrivateProfileString("CANBOOT", "wd_interval", "200", MyString, 20, INIFilePath)
    T_WatchDog.Interval = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "wd_maxcount", "10", MyString, 20, INIFilePath)
    pWatchDogTimer = CInt(MyString)
    
    crap = GetPrivateProfileString("CANBOOT", "boot_control", "4", MyString, 20, INIFilePath)
    pCANCtlId = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "boot_data", "5", MyString, 20, INIFilePath)
    pCANDataId = CInt(MyString)
    crap = GetPrivateProfileString("CANBOOT", "boot_code", "28", MyString, 20, INIFilePath)
    pBootCtlCode = CInt(MyString)
    
    crap = GetPrivateProfileString("CANBOOT", "mem_regions", "0", MyString, 20, INIFilePath)
    pRegions = CInt(MyString)
    
    If pRegions > 0 Then
        ReDim pStartAddr(pRegions) As Long
        ReDim pEndAddr(pRegions) As Long
        ReDim pBlockSize(pRegions) As Byte
        ReDim pProgressBlock(pRegions) As Integer
    
        For i = 0 To pRegions - 1
            crap = GetPrivateProfileString("CANBOOT_REGION" & CStr(i), "r_startaddr", "512", MyString, 20, INIFilePath)
            pStartAddr(i) = CLng(MyString)
            crap = GetPrivateProfileString("CANBOOT_REGION" & CStr(i), "r_endaddr", "513", MyString, 20, INIFilePath)
            pEndAddr(i) = CLng(MyString)
            crap = GetPrivateProfileString("CANBOOT_REGION" & CStr(i), "r_block", "0", MyString, 20, INIFilePath)
            pBlockSize(i) = CByte(MyString)
            crap = GetPrivateProfileString("CANBOOT_REGION" & CStr(i), "r_progressblock", "0", MyString, 20, INIFilePath)
            pProgressBlock(i) = CInt(MyString)
        Next i
    End If
    
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If ProgFlag <> True Then
        Unload F_DebugWindow
    Else
        Cancel = 1
    End If
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyEscape Then
        AbortFlag = True
    End If
    
End Sub




Public Sub Bootload()
        
    Dim Checksum As Long
       
    Dim CANMessage As mchpCANmsg
    
    On Error GoTo BootloadErrHandler
        
    ReDim CANMessage.CANData(8) As Byte
     
    
    AbortFlag = False
    ProgFlag = True
    
    DoEvents
    
    If pINIFileName = "" Then pINIFileName = GetFileName("Download HEX File To Device")
    PutStatusMsg STATUS_EXAMIN_FILE & pINIFileName
        
        If pINIFileName <> "" Then
            If HEXValidata(pINIFileName) Then
            
                F_Feedback.Caption = "Downloading (ESC to abort)"
            
                PutStatusMsg STATUS_VALID_HEX
            
                T_WatchDog.Enabled = True
                WatchDogTimer = pWatchDogTimer
                    
                CANComm1.OpenComm
                PutStatusMsg STATUS_CONNECTED & "COM" & CStr(CANComm1.CommPort) & " " & CStr(CANComm1.BitRate) & "bps"
                                                                             
                'Init and go on CAN bus
                CANComm1.SetMask 0
                CANComm1.SetFilter 0
                CANComm1.SetBitRate CANCtlBits
                CANComm1.Init CANCtlBits
                CANComm1.GoOnBus
                PutStatusMsg STATUS_CONNECTED_CAN
                
                'Init the target check registers
                If Not AbortFlag Then WriteControl pCANCtlId, 512, pBootCtlCode, 2, 0
                
                'Start loading the data
                For Icnt = 0 To (pRegions - 1)
                    If Not AbortFlag Then PutStatusMsg "Writing memory " & (Hex(pStartAddr(Icnt))) & " to " & (Hex(pEndAddr(Icnt) - 1))
                    Checksum = Checksum + WriteMemory(pINIFileName, pCANCtlId, pCANDataId, pBootCtlCode, pStartAddr(Icnt), pEndAddr(Icnt), pBlockSize(Icnt), pProgressBlock(Icnt))
                Next Icnt

                
                'Request normal mode (evaluate check)
                If Not AbortFlag Then WriteControl pCANCtlId, 512, pBootCtlCode, 3, (65536 - (Checksum And 65535))

                
                If AbortFlag Then PutStatusMsg "Operation aborted..."
                        
                  
                T_WatchDog.Enabled = False
                    
                CANComm1.GoOffBus
                PutStatusMsg STATUS_DISCONNECTED_CAN
                
                CANComm1.CloseComm
                PutStatusMsg STATUS_DISCONNECTED
                
                If AbortFlag Then
                    F_Feedback.Caption = "Download aborted"
                Else
                    F_Feedback.Caption = "Download complete"
                End If
            Else
                PutStatusMsg STATUS_INVALID_HEX
            End If
        Else
            PutStatusMsg STATUS_NOFILE
        
        End If
        
    ProgFlag = False
    
    Exit Sub
        
BootloadErrHandler:
    PutStatusMsg Err.Description
    
    T_WatchDog.Enabled = False
    ProgFlag = False
End Sub










Function WriteMemory(HEXFile As String, CANCtlId As Long, CANDataId As Long, BootCtlCode As Byte, StartAddr As Long, EndAddr As Long, BlockSize As Byte, ProgressBlock As Integer) As Long
    Dim CANMessage As mchpCANmsg
    ReDim CANMessage.CANData(8) As Byte
        
    If Not AbortFlag Then WriteControl pCANCtlId, StartAddr, pBootCtlCode, 0, 0
                    
                
    CANMessage.CANDatLen = BlockSize
    CANMessage.CANExtnd = True
    CANMessage.CANId = CANDataId
    CANMessage.CANRTR = False
                
    
    F_Feedback.ProgressBar1.Max = EndAddr - StartAddr
    F_Feedback.ProgressBar1.Min = 0
                   
    i = StartAddr
    Do While (i < EndAddr) And (Not AbortFlag)
                    
        WatchDogTimer = pWatchDogTimer
                                        
        For j = 0 To (BlockSize - 1)
            CANMessage.CANData(j) = HEXRead(HEXFile, CLng(i)) And 255
            WriteMemory = (WriteMemory + CANMessage.CANData(j)) And 65535
            i = i + 1
        Next j
                    
        Do While (Not CANComm1.IsPutMsgRdy) And (Not AbortFlag)
            DoEvents
        Loop
                     
        If Not AbortFlag Then CANComm1.PutMsg CANMessage
                                                
        If (i Mod ProgressBlock) = 0 Then
            ProgressBar1.Value = i - StartAddr
        End If
                                            
        DoEvents
    Loop
End Function


Sub WriteControl(CANCtlId As Long, StartAddr As Long, CtlCode As Byte, ImCmd As Byte, ImCmdDat As Long)
    Dim CANMessage As mchpCANmsg
    
    Do While (Not CANComm1.IsPutMsgRdy) And (Not AbortFlag)
        DoEvents
    Loop

    ReDim CANMessage.CANData(8) As Byte
    CANMessage.CANData(0) = StartAddr And 255
    CANMessage.CANData(1) = (StartAddr \ 256) And 255
    CANMessage.CANData(2) = (StartAddr \ 65536) And 255
    CANMessage.CANData(3) = 0
    CANMessage.CANData(4) = CtlCode
    CANMessage.CANData(5) = ImCmd
    CANMessage.CANData(6) = ImCmdDat And 255
    CANMessage.CANData(7) = (ImCmdDat \ 256) And 255
    
    CANMessage.CANDatLen = 8
    CANMessage.CANExtnd = True
    CANMessage.CANId = CANCtlId
    CANMessage.CANRTR = False
    
    CANComm1.PutMsg CANMessage
End Sub







Sub PutStatusMsg(TheMessage As String, Optional TheTime As Boolean = True)

    If TheTime Then
        F_DebugWindow.T_DebugBox.Text = F_DebugWindow.T_DebugBox.Text & Time & vbTab & TheMessage & vbCrLf
    Else
        F_DebugWindow.T_DebugBox.Text = F_DebugWindow.T_DebugBox.Text & vbTab & TheMessage & vbCrLf
    End If
    
    DoEvents

End Sub








Function GetFileName(dTitle As String) As String
    With CommonDialog1
        .DialogTitle = dTitle
        .CancelError = False
        .Flags = cdlOFNHideReadOnly
        .Filter = HEX_FILE_CONTROL_STRING
        .ShowOpen
                    '    if .Action
                
        GetFileName = .FileName
        .FileName = ""
    End With
End Function




Private Sub T_WatchDog_Timer()
    
    If WatchDogTimer Then
        WatchDogTimer = WatchDogTimer - 1
    Else
        AbortFlag = True
        PutStatusMsg "Time Out..."
    End If
    
End Sub
