Attribute VB_Name = "MEMIO"



Function ReadSRAM(ByVal PortHandle As Long, ByVal RWMaxRetrys As Integer, ByVal SRAMAddr As Integer, DataCount As Byte, SRAMData() As Byte) As Integer
    Dim picA As mchpPIC
    ReDim InData(DataCount + 6) As Byte
    
    picA.BootCmd = 8
    picA.BytesPerAddr = 1
    picA.BytesPerBlock = 1
    picA.MaxRetrys = RWMaxRetrys
    
    picA.BootDatLen = DataCount
    picA.BootAddr = CLng(SRAMAddr)
    
    ReadSRAM = ReadPIC(PortHandle, picA, InData(0))
    
    ReDim SRAMData(DataCount + 6) As Byte
    
    SRAMData = InData
    
    Erase InData
    
End Function


Function WriteSRAM(ByVal PortHandle As Long, ByVal RWMaxRetrys As Integer, ByVal SRAMAddr As Integer, ByVal DataCount As Byte, SRAMData() As Byte) As Integer
    Dim picA As mchpPIC
    ReDim OutData(UBound(SRAMData) + 6) As Byte
        
    picA.BootCmd = 9
    picA.BytesPerAddr = 1
    picA.BytesPerBlock = 1
    picA.MaxRetrys = RWMaxRetrys
    
    picA.BootDatLen = DataCount
    picA.BootAddr = CLng(SRAMAddr)
    
    OutData = SRAMData
    
    WriteSRAM = WritePIC(PortHandle, picA, OutData(0))
    
    Erase OutData
End Function
